#!/bin/sh
#-*-sh-*-

#
# Copyright © 2009 CNRS, INRIA, Université Bordeaux 1
#
# This software is a computer program whose purpose is to provide
# abstracted information about the hardware topology.
#
# This software is governed by the CeCILL-B license under French law and
# abiding by the rules of distribution of free software.  You can  use,
# modify and/ or redistribute the software under the terms of the CeCILL-B
# license as circulated by CEA, CNRS and INRIA at the following URL
# "http://www.cecill.info".
#
# As a counterpart to the access to the source code and  rights to copy,
# modify and redistribute granted by the license, users are provided only
# with a limited warranty  and the software's author,  the holder of the
# economic rights,  and the successive licensors  have only  limited
# liability.
#
# In this respect, the user's attention is drawn to the risks associated
# with loading,  using,  modifying and/or developing or reproducing the
# software by the user in light of its specific status of free software,
# that may mean  that it is complicated to manipulate,  and  that  also
# therefore means  that it is reserved for developers  and  experienced
# professionals having in-depth computer knowledge. Users are therefore
# encouraged to load and test the software's suitability as regards their
# requirements in conditions enabling the security of their systems and/or
# data to be ensured and,  more generally, to use and operate it in the
# same conditions as regards security.
#
# The fact that you are presently reading this means that you have had
# knowledge of the CeCILL-B license and that you accept its terms.
#

: ${TMPDIR=/tmp}
{
  tmp=`
    (umask 077 && mktemp -d "$TMPDIR/fooXXXXXX") 2>/dev/null
  ` &&
  test -n "$tmp" && test -d "$tmp"
} || {
  tmp=$TMPDIR/foo$$-$RANDOM
  (umask 077 && mkdir "$tmp")
} || exit $?
file="$tmp/test-topodistrib.output"

set -e
(
  ./topodistrib --synthetic "2 2 2" 2
  echo
  ./topodistrib --synthetic "2 2 2" 4
  echo
  ./topodistrib --synthetic "2 2 2" 8
  echo
  ./topodistrib --synthetic "2 2 2" 13
  echo
  ./topodistrib --synthetic "2 2 2" 16
  echo
  ./topodistrib --synthetic "3 3 3" 4
) > "$file"
diff -u $srcdir/test-topodistrib.output "$file"
rm -rf "$tmp"
